<template>
  <div class="wrapper">
    <div class="container-fuild">
      <div id="headTitle">
        <Logo />
        <h1 id="title" _msttexthash="48503" _msthash="2">{{ i18ntext.lngText('view_pre') }}</h1>
      </div>
    </div>
    <div class="container-fuild">
      <Header />
      <ol id="topicPath">
        <li style="margin-left: 341px">
          <router-link to="dashbaord">
            <a href="dashbaord">
              <font style="vertical-align: inherit"></font>
              <font style="vertical-align: inherit"> {{ i18ntext.lngText('view_pre') }} </font>
            </a>
          </router-link>
        </li>
      </ol>
      <div class="search-box">
        <div id="product">
          <div class="search-box">
            <div class="search-box-title" id="Bars">
              <div id="bar" style="width: 90%;gap: 0;">
                <router-link to="/pos">
                                    <a class="btn-radius btn btn-sm" href="#"
                                        style="color: #f8f5b4; margin-top: -2px; color: #dbdee1">
                                        <i class="fa fa-cog" aria-hidden="true"></i>
                                        {{ i18ntext.lngText('POS') }}
                                    </a>
                                </router-link>
                                <router-link to="/patientRegister">
                                    <a class="btn-radius btn btn-sm" href="#"
                                        style="margin-top: -2px; border: #22adb763 1px solid;">
                                        <i class="fa fa-cog" aria-hidden="true"></i>
                                        {{ i18ntext.lngText('patient') }}
                                    </a>
                                </router-link>
                                <router-link to="/Laboratory" data-bs-toggle="dropdown" aria-expanded="false">
                                    <a class="btn-radius btn btn-sm" href="#"
                                        style="color: #f8f5b4; margin-top: -2px; color: #dbdee1">
                                        <i class="fas fa-plus" style="margin-top: -2px;"></i>
                                        {{ i18ntext.lngText('labo') }}
                                    </a>
                                </router-link>
                                <ul class="dropdown-menu" style="padding:6px;">
                                    <li>
                                        <router-link to="/Laboratory">
                                            <a class="btn-radius btn btn-sm down" href="#" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-bottom: 10px;margin-top: 0;margin-right: 0;width: 100%;text-align: left;">
                                                <i class="fa fa-cog" aria-hidden="true"></i>
                                                {{ i18ntext.lngText('labo') }}
                                            </a>
                                        </router-link>
                                    </li>
                                    <li>
                                        <router-link to="/Viewlaboratory">
                                            <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                                                <i class="fa fa-cog" aria-hidden="true"></i>
                                                {{ i18ntext.lngText('viewLabo') }}
                                            </a>
                                        </router-link>
                                    </li>
                                </ul>
                                <router-link to="/prescription" data-bs-toggle="dropdown" aria-expanded="false">
                                    <a class="btn-radius btn btn-sm" href="#"
                                        style="color: #f8f5b4;background-color: #29a5a5; margin-top: -2px; color: #dbdee1">
                                        <i class="fas fa-plus" style="margin-top: -2px;"></i>
                                        {{ i18ntext.lngText('prescription') }}
                                    </a>
                                </router-link>
                                <ul class="dropdown-menu" style="padding:6px;">
                                    <li>
                                        <router-link to="/prescription">
                                            <a class="btn-radius btn btn-sm down" href="#" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-bottom: 10px;margin-top: 0;margin-right: 0;width: 100%;text-align: left;">
                                                <i class="fa fa-cog" aria-hidden="true"></i>
                                                {{ i18ntext.lngText('prescription') }}
                                            </a>
                                        </router-link>
                                    </li>
                                    <li>
                                        <router-link to="/prescriptionview">
                                            <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                                                <i class="fa fa-cog" aria-hidden="true"></i>
                                                {{ i18ntext.lngText('view_pre') }}
                                            </a>
                                        </router-link>
                                    </li>
                                </ul>

                                <router-link to="/viewall">
                                    <a class="btn-radius btn btn-sm" href="#"
                                        style="color: #f8f5b4; margin-top: -2px; color: #dbdee1;">
                                        <i class="fa fa-cog" aria-hidden="true"></i>
                                        {{ i18ntext.lngText('view_all') }}
                                    </a>
                                </router-link>



              </div>
              <div id="right" style="width: 10%">
                <a
                  class="btn-radius bt-pn btn btn-sm"
                  data-bs-toggle="dropdown"
                  aria-expanded="false"
                  style="
                    float: right;
                    color: #f8f5b4;
                    margin-top: -2px;
                    margin-right: 11px;
                  "
                >
                  <i class="fas fa-plus" style="padding-right: 5px"> </i>
                  {{ i18ntext.lngText('menu') }}
                </a>
                <ul class="dropdown-menu">
                  <li>
                    <a
                      class="dropdown-item btn btn-primary"
                      data-bs-toggle="modal"
                      data-bs-target="#staticboomId"
                      tabindex="10028"
                      ><i class="fa fa-print" aria-hidden="true"></i> {{ i18ntext.lngText('print') }}</a
                    >
                  </li>
                </ul>
              </div>
            </div>
            <input autocomplete="off" id="search" name="search" type="hidden" value="1" />
            <input autocomplete="off" id="search" name="search" type="hidden" value="1" />
            <div class="box">
              <div class="box-content">
                <table
                  width="100%"
                  border="0"
                  cellpadding="0"
                  cellspacing="0"
                  class="table table-striped br-table"
                >
                  <thead>
                    <tr class="header-table">
                      <th colspan="7" style="width: 55em">
                        <input autocomplete="off"
                          @change="changeSearchText(pre_search.name, 'name')"
                          @input="getview()"
                          v-model="pre_search.name"
                          id="search"
                          name="search"
                          type="search"
                          class="text"
                          :placeholder="i18ntext.lngText('pre_id')+','+i18ntext.lngText('patient_name')+','+i18ntext.lngText('phonenumber')+','+ i18ntext.lngText('address')"
                          style="width: 100%"
                        />
                      </th>
                      <th colspan="2" class="exp">
                        <div>
                          <span>
                            <input autocomplete="off"
                              @change="changeSearchText(pre_search.startDate, 'start')"
                              v-model="pre_search.startDate"
                              type="date"
                              class="text"
                              placeholder="Search"
                              style="margin-right: 0px !important" /></span
                          ><span style="margin: 0px 10px">To</span
                          ><span>
                            <input autocomplete="off"
                              @change="changeSearchText(pre_search.endDate, 'end')"
                              v-model="pre_search.endDate"
                              id="search"
                              name="search"
                              type="date"
                              class="text"
                              placeholder="Search"
                              style="margin-right: 0px !important"
                          /></span>
                        </div>
                      </th>
                      <th></th>
                      <th>
                        <div
                          @click="getview()"
                          class="button type2"
                          id="uniform-undefined"
                        >
                          <span
                            ><input autocomplete="off"
                              type="button"
                              class="type2"
                              tabindex="10025"
                              value="display"
                              style="opacity: 0; width: 54px"
                            /><i class="fa fa-search"></i> {{i18ntext.lngText('search')}}</span
                          >
                        </div>
                      </th>
                    </tr>
                    <tr class="header-table">
                      <th width="5%">{{i18ntext.lngText('no')}}</th>
                      <th width="10%">{{i18ntext.lngText('name')}}</th>
                      <th>{{i18ntext.lngText('sex')}}</th>
                      <th>{{i18ntext.lngText('age')}}</th>
                      <th>{{i18ntext.lngText('diangosis')}}</th>
                      <th width="10%">{{i18ntext.lngText('phonenumber')}}</th>
                      <th>{{i18ntext.lngText('address')}}</th>
                      <th>{{i18ntext.lngText('date')}}</th>
                      <th>{{i18ntext.lngText('appointment')}}</th>
                      <th width="10%">{{i18ntext.lngText('remark')}}</th>
                      <th></th>
                    </tr>
                  </thead>
                  <tbody id="view">
                    <tr v-for="(reg, index) in getpres.data" :key="index">
                      <td>{{ 15*(number - 1)  + (index + 1)}}</td>
                      <td>{{ reg.firstname }} {{ reg.lstname }}</td>
                      <td>{{ reg.sex }}</td>
                      <td>{{ reg.age }}</td>
                      <td>{{ reg.group_code }}</td>
                      <td>{{ reg.phone1 }}</td>
                      <td>
                        {{ reg.address }} {{ reg.village }} {{ reg.commune }}
                        {{ reg.district }}
                        {{ reg.pro_city }}
                      </td>
                      <td v-if="reg.visit_date != null">
                        {{ formatdatetime(reg.visit_date) }}
                      </td>
                      <td v-else>
                        {{ reg.appointment_date }}
                      </td>
                      <td v-if="reg.appointment_date != null">
                        {{ formatdatetime(reg.appointment_date) }}
                      </td>
                      <td v-else>{{ reg.appointment_date }}</td>
                      <td>{{ reg.remark }}</td>
                      <td class="text-center d-flex">
                        <div class="button type2" @click="createvisit(reg.preid)">
                          <span
                            ><input autocomplete="off"
                              type="button"
                              value="display"
                              class="type2"
                              style="opacity: 0; width: 54px"
                              tabindex="10025"
                            />{{i18ntext.lngText('detail')}}</span
                          >
                        </div>
                        <div
                          v-if="reg.status == 'open'"
                          class="button type2"
                          @click="deletePrescription(reg.preid)"
                        >
                          <span
                            ><input autocomplete="off"
                              type="button"
                              value="display"
                              class="type2"
                              style="opacity: 0; width: 54px"
                              tabindex="10025"
                            />{{i18ntext.lngText('Delete')}}</span
                          >
                        </div>
                        <div v-else class="button type2" @click="cannotDelete()">
                          <span
                            ><input autocomplete="off"
                              type="button"
                              value="display"
                              class="type2"
                              style="opacity: 0; width: 54px"
                              tabindex="10025"
                            />{{i18ntext.lngText('Delete')}}</span
                          >
                        </div>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
              <div class="box-footer-pagination">
                <pagination :limit="2" :data="getpres" @pagination-change-page="getview" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div
    class="modal fade ui-modal"
    id="staticboomId"
    data-bs-backdrop="static"
    data-bs-keyboard="false"
    tabindex="-1"
    aria-labelledby="staticboomId"
    aria-hidden="true"
  >
    <div class="modal-dialog" style="max-width: 65% !important">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title in-header" id="staticBackdropLabel">
            <i class="fa fa-print" aria-hidden="true"></i> {{i18ntext.lngText('print')}}
          </h5>
          <span
            class="ui-icon ui-icon-closethick"
            data-bs-dismiss="modal"
            aria-label="Close"
          ></span>
        </div>
        <div class="ui-dialog-content">
          <div class="card">
            <div class="card-body">
              <div class="mt-3 print-size">
                <div style="padding: 0 50px 0 50px" id="printProduct">
                  <div class="col-md-12">
                    <div class="text-center">
                      <h3 class="title-purchase">{{i18ntext.lngText('report')}} {{i18ntext.lngText('view_pre')}}</h3>
                    </div>
                  </div>

                  <div class="col-container">
                    <div class="col1" style="width: 55%">
                      <p class="p-bg font-size p-pad">{{i18ntext.lngText('company')}}</p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{i18ntext.lngText('name')}} :</span>
                        <span id="fon">{{ company.company_name }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{i18ntext.lngText('phonenumber')}} :</span>
                        <span id="fon">{{ company.company_Phone }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{i18ntext.lngText('email')}} :</span>
                        <span id="fon">{{ company.company_Email }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{i18ntext.lngText('address')}} :</span>
                        <span id="fon">{{ company.company_Address }}</span>
                      </p>
                    </div>
                    <div class="col2">
                      <p class="text-center p-bg font-size p-pad">{{i18ntext.lngText('date')}}</p>
                      <p class="text-center p-mg" id="fon">{{ dateformart }}</p>
                      <p class="text-center p-bg font-size p-pad">{{i18ntext.lngText('total')}} {{i18ntext.lngText('view_pre')}}</p>
                      <p class="text-center p-mg" id="fon">{{ getpres.total }}</p>
                    </div>
                  </div>
                  <div class="my-2 justify-content-center">
                    <table id="pr-tb">
                      <thead>
                        <tr class="p-bg">
                          <th width="3%" class="text-center">{{i18ntext.lngText('no')}}</th>
                          <th class="text-center">{{i18ntext.lngText('name')}}</th>
                          <th class="text-center">{{i18ntext.lngText('sex')}}</th>
                          <th class="text-center">{{i18ntext.lngText('age')}}</th>
                          <th class="text-center">{{i18ntext.lngText('phonenumber')}}</th>
                          <th class="text-center">{{i18ntext.lngText('address')}}</th>
                          <th class="text-center">{{i18ntext.lngText('date')}}</th>
                          <th class="text-center">{{i18ntext.lngText('appointment')}}</th>
                          <th class="text-center">{{i18ntext.lngText('remark')}}</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr v-for="(reg, index) in printData" :key="index">
                          <td>{{ index + 1 }}</td>
                          <td style="padding-right: 5px">
                            {{ reg.firstname }} {{ reg.lstname }}
                          </td>
                          <td>{{ reg.sex }}</td>
                          <td>{{ reg.age }}</td>
                          <td>{{ reg.phone1 }}</td>
                          <td>
                            {{ reg.pro_city }}
                          </td>
                          <td v-if="reg.visit_date != null">
                            {{ formatdatetime(reg.visit_date) }}
                          </td>
                          <td v-else>{{ reg.visit_date }}</td>
                          <td v-if="reg.appointment_date != null">
                            {{ formatdatetime(reg.appointment_date) }}
                          </td>
                          <td v-else>{{ reg.appointment_date }}</td>
                          <td>{{ reg.remark }}</td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                  <hr />
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <a
            v-print="'#printProduct'"
            class="btn-purchase btn-light text-capitalize border-0"
            data-mdb-ripple-color="dark"
            ><i class="fas fa-print text-primary"></i> {{ i18ntext.lngText('print') }}</a
          >
        </div>
      </div>
    </div>
  </div>
  <div id="myModal" class="lskymodal">
    <div class="lskymodal-content">
      <p><i class="fa fa-check" aria-hidden="true"></i> {{ message }}</p>
    </div>
  </div>

  <Footer/>
  <UserInfo />

</template>

<script>
import Auth from "../../auth/Auth";
import Header from "../Header.vue";
import axios from "axios";
import moment from "moment";
import print from "vue3-print-nb";
import Footer from "../footer.vue";
import i18n from "../../i18n/i18n";
import UserInfo from "../UserInfo.vue";
import Logo from "../logo.vue";
import pagination from "laravel-vue-pagination";
export default {
  name: "prescriptions",
  components: { Header, pagination, Logo,Footer,UserInfo },
  directives: { print },
  data() {
    return {
      i18ntext: i18n,
      labo: 20,
      pre: "",
      fullname: "",
      Address: "",
      getpres: [],
      company: [],
      message: "",
      total: 0,
      form: {
        sex: "",
        preid: "",
        paid: "",
        lstname: "",
        firstname: "",
        Age: "",
        visit_date: "",
        pateinid: "",
        birstdate: "",
        remark: "",
        appointment_date: "",
        age: "",
        allergies: "",
        history_disease: "",
        bp: "",
        pr: "",
        rr: "",
        spo2: "",
        t: "",
        address: "",
        village: "",
        commune: "",
        district: "",
        pro_city: "",
        phone1: "",
      },
      search: {
        pateinid: "",
        lstname: "",
        firstname: "",
        phone1: "",
        address: "",
        village: "",
        commune: "",
        district: "",
        pro_city: "",
        visit_date: "",
        appointment_date: "",
        remark: "",
      },
      pre_search: {
        name: "",
        startDate: "",
        endDate: "",
      },
      printData : [],
      number_page : 1,
      number : 1,
    };
  },
  mounted() {
    if (Auth.check()) {
      if (!Auth.checkPermission("PRESCRIPTION_ALL")) {
        this.$router.push("/dashboard");
      }
    }
    if(this.$route.query.page != 1){
      this.number_page = this.$route.query.page
      axios.post("/api/v1/prescription/getPrescription?page=" + this.number_page,this.pre_search).then(({ data }) => {
        this.getpres = data.data;
        this.printData = data.print
        this.total = this.getpres.length;
      });
    }else{
      this.getview();
    }
    let myPagenumber = this.$route.query
     if(JSON.stringify(myPagenumber) === '{}'){
        this.number = 1
     } 
     else {
      this.number = this.$route.query.page
     }
    
    this.getcompany();
  },
  methods: {
    getview(page = 1) {
      this.$router.push({name: 'prescriptionview', query: {page : page}})
      axios.post("/api/v1/prescription/getPrescription?page=" + page,this.pre_search).then(({ data }) => {
        this.getpres = data.data;
        this.printData = data.print
        this.total = this.getpres.length;
        this.number = this.$route.query.page
      });
    },
    searchPrescription() {},
    createvisit(preid) {
      this.$router.push({ name: "prescription", query: { preId: preid } });
    },
    formatdatetime(dateform) {
      try {
        return   moment(dateform).format("DD-MM-YYYY hh:mm");
      } catch (error) {
        return dateform;
      }
    },
    getcompany() {
      axios.get("/api/v1/getSetup/").then((response) => {
        this.company = response.data;
        this.dateformart = moment(new Date()).format("DD-MM-YYYY");
      });
    },
    changeSearchText(value, label) {
      if (label === "name") {
        this.pre_search = {
          name: value,
          startDate: "",
          endDate: "",
        };
      }
      if (label === "start") {
        this.pre_search = {
          name: "",
          startDate: value,
          endDate: this.pre_search.endDate,
        };
      }
      if (label === "end") {
        this.pre_search = {
          name: "",
          startDate: this.pre_search.startDate,
          endDate: value,
        };
      }
    },
 
    messagebox() {
      var modal = document.getElementById("myModal");
      modal.style.display = "block";
      setTimeout(() => (modal.style.display = "none"), 2000);
    },
    getDefault() {
      if (this.pre_search.name == "") {
        this.getview();
      }
    },
    deletePrescription(id) {
      axios.get("api/v1/prescription/deletePrescription/" + id).then((res) => {
        this.getview();
        this.message = "Deleted successfully.";
        this.messagebox();
      });
    },
    cannotDelete() {
      this.message = "Can't delete, This is already successfully!";
      this.messagebox();
    },
  },
};
</script>
